//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#include <Trade\Trade.mqh>
// Idea - https://www.mql5.com/ru/code/7464
#property strict

input int Shift = 3;
input int Limit = 18;
input double Lots=0.1;
int PrevBid,PrevAsk;
CTrade trade;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int PriceToInteger(const double Price)
  {
   return((int)(Price / _Point + 0.1));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   MqlTick tick;
   if(!SymbolInfoTick(_Symbol,tick)) return;

   if(PrevBid==0)
     {
      PrevBid=PriceToInteger(tick.bid);
      PrevAsk=PriceToInteger(tick.ask);
     }

   const int IntBid = PriceToInteger(tick.bid);
   const int IntAsk = PriceToInteger(tick.ask);

   const bool TradeTime=(TimeCurrent()%(24*60*60)<D'1970.01.01 23:50'); // exclude swaps

   if(TradeTime && (IntAsk-IntBid<Limit))
     {
      if((IntBid-PrevBid>=Shift))
         trade.Sell(Lots,_Symbol,tick.bid,0,0);

      if(PrevAsk-IntAsk>=Shift)
         trade.Buy(Lots,_Symbol,tick.ask,0,0);
     }

   PrevBid = IntBid;
   PrevAsk = IntAsk;

   int total=PositionsTotal();
   for(int i=total-1;i>=0;i--)
     {
      ulong ticket=PositionGetTicket(i);

      if(!TradeTime
         || 
         PositionGetDouble(POSITION_PROFIT)>0
         || 
         (PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY && PriceToInteger(PositionGetDouble(POSITION_PRICE_OPEN))-IntBid>=Limit)
         || 
         (PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL && IntAsk-PriceToInteger(PositionGetDouble(POSITION_PRICE_OPEN))>=Limit)
         )
        {
         trade.PositionClose(ticket);
        }
     }
  }
//+------------------------------------------------------------------+
